try:
    from setuptools import setup, find_packages
except ImportError:
    from ez_setup import use_setuptools
    use_setuptools()
    from setuptools import setup, find_packages

setup(
    name='Trio',
    version="1.1.3",
    description='Trio: A System for Data, Uncertainty, and Lineage',
    author='Stanford InfoLab',
    author_email='triohelp@db.stanford.edu',
    url='http://infolab.stanford.edu/trio/',
    install_requires=["PyGreSQL>=4.0",
                      "ply==2.5"],
    packages=find_packages(exclude=['ez_setup']),
    include_package_data=True,
    license='BSD',
    entry_points="""
    [console_scripts]
    triospi_install = trio.spi.triospi_install:main
    trioplus = trioplus.trioplus:main
    triosetupdb = trioplus.triosetupdb:main
    triotest = test.triotest:main
    """,
)
