__id__ = "$Id$"

from trio.node import *

class CommandExecutor:
    def execute(self, node, trio_cursor):
        command = node.value[1:]
        executefn = getattr(self, 'execute_'+command, self.executeDefault)
        executefn(node, trio_cursor)

    def executeDefault(self, node, trio_cursor):
        raise Exception("Unsupported command: %s" % node.value)

    def execute_d(self, node, trio_cursor):
        cursor = trio_cursor.tdb.pdb.cursor()
        if isinstance(node.children[0], Empty):
            query = "SELECT DISTINCT tablename as table FROM trio_tables WHERE istemporary = false"
        else:
            query = "SELECT attrname FROM trio_attribs WHERE tablename = '%s' ORDER BY colnum" \
                    % node.children[0].value

        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_c(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\l table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = "SELECT DISTINCT tablename as table FROM trio_tables_lin WHERE srctable = '%s'" % table

        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_l(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\l table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = ("SELECT t.tablename FROM trio_tables t, trio_tables_lin tl "
                 + "WHERE tl.tablename = '%s' and t.tablename = tl.srctable") % table

        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True

    def execute_t(self, node, trio_cursor):
        if len(node.children) > 1 or isinstance(node.children[0], Empty):
            raise Exception("\t table_name")
        table = node.children[0].value
        cursor = trio_cursor.tdb.pdb.cursor()
        query = "SELECT type FROM trio_tables WHERE tablename = '%s'" % table

        cursor.execute(query)
        trio_cursor.cursor = cursor
        trio_cursor.description = cursor.description
        trio_cursor.isXCursor = False
        trio_cursor.isFetchable = True
