__id__ = "$Id$"

def execute(node, trio_cursor):
    index = node.children[0].value
    name = node.children[1].value

    # Fetch uncertain columns
    u_columnnames = []
    cursor = trio_cursor.tdb.pdb.cursor()
    sql = "SELECT attrname FROM trio_attribs WHERE tablename = '%s' and iscertain = false ORDER BY colnum asc" % name
    cursor.execute(sql)
    cols = cursor.fetchall()
    for c in cols:
        u_columnnames.append(c[0])

    # Map certain and uncertain index columns
    c_cols = []
    u_cols = []
    for child in node.children[2].children:
        if child.value in u_columnnames:
            u_cols.append(child.value)
        else:
            c_cols.append(child.value)

    # Create indexes on data columns & X-ID
    if c_cols:
        cursor.execute("CREATE INDEX trio_idx_c_%s ON trio_c_%s (trio_xid, %s)"
                       % (index, name,  ", ".join(c_cols)))
    if u_cols:
        cursor.execute("CREATE INDEX trio_idx_u_%s ON trio_u_%s (trio_xid, %s)"
                       % (index, name, ", ".join(u_cols)))

    cursor.close()
