__id__ = "$Id$"

from trio import common
from trio.node import *

def execute(node, trio_cursor, isRoot=True):
    trio_cursor.isFetchable = False
    tables = [x.value for x in node.children[0].children]

    c = trio_cursor.tdb.pdb.cursor()

    for table in tables:
        query = ("SELECT DISTINCT trio_tables_lin.tablename "
                 + "FROM trio_tables_lin, trio_tables "
                 + "WHERE trio_tables_lin.tablename = trio_tables.tablename "
                 + "and istemporary = false and srctable = '%s'") % table
        c.execute(query)

        # Recursively cascade over derived tables
        derived_tables = [tuple[0] for tuple in c.fetchall()]
        if isinstance(node.children[1], Cascade) and len(derived_tables) > 0:
            # Recursively drop all the derived tables.
            for child in derived_tables:
                if table != child:
                    trio_cursor.execute("Drop Table %s Cascade" % child)
                # Remove the table from the list since the table has already been dropped
                if child in tables:
                    tables.remove(child)
        elif len(derived_tables) > 0:
            raise Exception("Cannot drop table that has derived tables!")

        # Drop all entries related to this table
        c.execute("DROP VIEW %s" % table)
        c.execute("DROP TABLE IF EXISTS trio_c_%s, trio_u_%s, trio_lin_%s, trio_x_lin_%s CASCADE"
                  % (table, table, table, table))
        c.execute("DROP SEQUENCE IF EXISTS trio_xid_%s, trio_aid_%s" % (table, table))
        c.execute("DELETE FROM trio_tables WHERE tablename = '%s'" % table)
        c.execute("DELETE FROM trio_tables_lin WHERE tablename = '%s'" % table)
        c.execute("DELETE FROM trio_attribs WHERE tablename = '%s'" % table)

    c.close()
