#!/usr/bin/env python

__id__ = "$Id$"

import os
import sys
import subprocess
import shutil
from trio.common import ROOT

def pg_config(s):
    pipe = subprocess.Popen(["pg_config", "--%s" % s], stdout=subprocess.PIPE).stdout
    return pipe.readline().strip()

def main(argv=None):
    if sys.platform == "win32":
        dlsuffix = ".dll"
    else:
        dlsuffix = ".so"

    try:
        pkglibdir = pg_config("pkglibdir")
        if not os.path.exists(pkglibdir):
            raise Exception("pkglibdir %s doesn't exist." % pkglibdir)
        version = pg_config("version").replace('.', ' ').split()
    except Exception, e:
        print "pg_config: %s" % str(e)
        print "Please install triospi%s manually from %s." % (dlsuffix, os.path.join(ROOT, "spi"))
        return 1

    pg_version = "pg-%s.%s" % (version[1], version[2])
    ldlibrary = os.path.join(ROOT, "spi", sys.platform, pg_version, "triospi%s" % dlsuffix)
    if not os.access(ldlibrary, os.F_OK):
        print "Pre-compiled triospi%s for this platform doesn't exist." % dlsuffix
        print "Please compile triospi%s at %s and install it into %s" % (dlsuffix, os.path.join(ROOT, "spi"), pkglibdir)
        return 1

    print "Copying %s to %s" % (ldlibrary, pkglibdir)
    try:
        shutil.copy(ldlibrary, pkglibdir)
    except Exception, e:
        print str(e)
        return 1

    return 0

if __name__ == "__main__":
    sys.exit(main())
