CREATE OR REPLACE FUNCTION eminmax(text) RETURNS float8 AS
$$
DECLARE
    cprob float8;
    cval float8;

    val float8;
    conf float8;
    xid int;

    cumulative_conf float8[];
    eminrecord record;
BEGIN
    cprob := 1;
    cval := 0;
--    raise notice '%', cprob;
    for eminrecord in execute $1 loop
        val := eminrecord.trio_val;
        conf := eminrecord.conf;
        xid := eminrecord.trio_xid;
--        raise notice 'val %', val;
--        raise notice 'conf %', conf;
--        raise notice 'xid %', xid;
--        raise notice 'cval = %', cval;
--        raise notice 'cprob before %', cprob;
--        raise notice 'cumulative_conf before % %', xid, cumulative_conf[xid];
        if cumulative_conf[xid] is null then
            cumulative_conf[xid] := 0;
            -- raise notice 'cumulative_conf before % %', xid, cumulative_conf[xid];
        end if;

        if cprob < 1 then
            cprob := cprob / (1-cumulative_conf[xid]);
        end if;
        cval := cval + cprob*conf*val;

        cumulative_conf[xid] := cumulative_conf[xid] + conf;
--        raise notice 'cumulative_conf after % %', xid, cumulative_conf[xid];

        if(cumulative_conf[xid] = 1) then
            exit;
        end if;
        cprob := cprob * (1-cumulative_conf[xid]);

        --to prevent underflow
        if(cprob < 0.00000000000000000000001) then
            exit;
        end if;

    end loop;
    cprob := 1;
    xid = 1;
    while (xid <= array_upper(cumulative_conf, 1)) loop
        -- raise notice 'cprob = %, xid = %, conf = %', cprob, xid, cumulative_conf[xid];
        if cumulative_conf[xid] = 1 then
            cprob := 1;
            exit;
        end if;
        cprob := cprob * (1 - cumulative_conf[xid]);
        xid := xid + 1;
    end loop;
    -- raise notice 'cprob = %', cprob;
    if cprob = 1 then
        -- found a certain x-tuple
        return cval;
    else
        -- no certain x-tuple, so compensate for empty possible instance
        return cval / (1 - cprob);
    end if;
END;
$$ LANGUAGE plpgsql;

