CREATE OR REPLACE FUNCTION havg(text, text) RETURNS float8 AS
$$
DECLARE
    msum float8;
    mcount int;

    maxattr float8;
    havg float8;

    irecord record;
    nrecord record;
BEGIN
    for irecord in execute $1 loop
        msum := irecord.msum;
        mcount := irecord.mcount;
        --raise notice 'msum %', msum;
        --raise notice 'mcount %', mcount;
    end loop;

    for nrecord in execute $2 loop
        maxattr := nrecord.maxattr;
        --raise notice 'maxattr %', maxattr;
        if ((msum+maxattr)/(mcount+1)) <= (msum/mcount) then
            exit;
        end if;

        mcount := mcount + 1;
        msum := msum + maxattr;

    end loop;
    havg := (msum/mcount);
    --raise notice 'havg = %', havg;
    return havg;
END;
$$ LANGUAGE plpgsql;

