CREATE OR REPLACE FUNCTION lavg(text, text) RETURNS float8 AS
$$
DECLARE
    msum float8;
    mcount int;

    minattr float8;
    lavg float8;

    irecord record;
    nrecord record;
BEGIN
    for irecord in execute $1 loop
        msum := irecord.msum;
        mcount := irecord.mcount;
        --raise notice 'msum %', msum;
        --raise notice 'mcount %', mcount;
    end loop;

    for nrecord in execute $2 loop
        minattr := nrecord.minattr;
        --raise notice 'minattr %', minattr;
        if ((msum+minattr)/(mcount+1)) >= (msum/mcount) then
            exit;
        end if;

        mcount := mcount + 1;
        msum := msum + minattr;

    end loop;
    lavg := (msum/mcount);
    --raise notice 'lavg = %', lavg;
    return lavg;
END;
$$ LANGUAGE plpgsql;

