CREATE OR REPLACE FUNCTION lavgmain(text, text) RETURNS setof numg AS
$$
DECLARE
    msum float8;
    mcount int;

    minattr float8;
    lavg float8;

    irecord record;
    nrecord record;

    orecord record;
    ofound bool;

    curs1 refcursor;
    curs2 refcursor;

    gi text[];
    gn text[];

    r numg;
BEGIN
    open curs1 for execute $1;
    open curs2 for execute $2;

    ofound := false;

    loop
        fetch curs1 into irecord;
        if not found then
            exit;
        end if;
        msum := irecord.msum;
        mcount := irecord.mcount;
        gi := irecord.g;

        --raise notice 'msum %', msum;
        --raise notice 'mcount %', mcount;
        --raise notice 'gi %', gi;

        if ofound then
            --raise notice 'ofound';
            --raise notice 'oma %', orecord.minattr;
            --raise notice 'og %', orecord.g;
            if orecord.g = gi then
                ofound = false;
                minattr = orecord.minattr;

                if ((msum+minattr)/(mcount+1)) < (msum/mcount) then
                    mcount := mcount + 1;
                    msum := msum + minattr;
                end if;
            end if;
        end if;
                

        loop
            if ofound = true then
                exit;
            end if;
            fetch curs2 into nrecord;
            --raise notice 'nma %', nrecord.minattr;
            --raise notice 'ng %', nrecord.g;
            if not found then
                exit;
            end if;
            if nrecord.g > irecord.g then
                orecord = nrecord;
                ofound = true;
                exit;
            end if;
            if nrecord.g < irecord.g then
                continue;
            end if;

            minattr := nrecord.minattr;
            --raise notice 'minattr %', minattr;
            if ((msum+minattr)/(mcount+1)) >= (msum/mcount) then
                exit;
            end if;

            mcount := mcount + 1;
            msum := msum + minattr;

        end loop;

        lavg := (msum/mcount);
        --raise notice 'lavg = %', lavg;
        --raise notice 'gi = %', gi;
        r.a := lavg;
        r.g := gi;
        return next r;

    end loop;

    close curs1;
    close curs2;
    return;
END;
$$ LANGUAGE plpgsql;

