#!/usr/bin/env python

__id__ = "$Id$"

import sys
import optparse
import os
import tempfile
import fileinput
from trio.common import ROOT, SQL_FILES

def main(argv=None):
    if argv is None:
        argv = sys.argv

    p = optparse.OptionParser(usage="%prog [options] dbname [username]")
    p.add_option("-U", dest="user", help="database superuser name")

    (options, args) = p.parse_args()

    if len(args) == 2:
        user = args[1]
    elif len(args) == 1:
        user = ""
    else:
        p.error("incorrect number of arguments")

    if options.user is not None:
        superuser = options.user
    else:
        superuser = ""

    tmp = tempfile.mkstemp()
    for line in fileinput.input(SQL_FILES):
        os.write(tmp[0], line)
    os.close(tmp[0])

    os.system("psql -f %s %s %s" % (tmp[1], args[0], superuser))
    os.system("psql -f %s %s %s" % (os.path.join(ROOT, 'sql', 'setup.sql'), args[0], user))

    os.remove(tmp[1])

if __name__ == "__main__":
    sys.exit(main())
